#include "pass_through_filter.hpp"
#include "workflow_graph.hpp"

namespace xios
{
  CPassThroughFilter::CPassThroughFilter(CGarbageCollector& gc, bool buildWorkflowGraph /*= false*/)
    : CFilter(gc, 1, this, buildWorkflowGraph)
  { 
  }

  CDataPacketPtr CPassThroughFilter::apply(std::vector<CDataPacketPtr> data)
  {
  	if(this->tag)
    {
      std::cout<<"CPassThroughFilter::apply tag = "<<this->tag<<std::endl;
      this->filterID = InvalidableObject::filterIdGenerator++;
      if(CWorkflowGraph::mapFilters_ptr==0) CWorkflowGraph::mapFilters_ptr = new std::unordered_map <int, StdString>;

      (*CWorkflowGraph::mapFilters_ptr)[this->filterID] = "Pass Through Filter";

      if(CWorkflowGraph::mapFieldToFilters_ptr==0) CWorkflowGraph::mapFieldToFilters_ptr = new std::unordered_map <StdString, vector <int> >;
      
      StdString str = data[0]->fieldID + " ts=" + to_string(data[0]->timestamp);
      (*CWorkflowGraph::mapFieldToFilters_ptr)[str].push_back(data[0]->src_filterID);
      (*CWorkflowGraph::mapFieldToFilters_ptr)[str].push_back(this->filterID);
      data[0]->src_filterID=this->filterID;

    }
    
    data[0]->fieldID = this->output_field_id;
    

    return data[0];
  }

} // namespace xios
