#include "unary_arithmetic_filter.hpp"
#include "workflow_graph.hpp"
namespace xios
{
  CUnaryArithmeticFilter::CUnaryArithmeticFilter(CGarbageCollector& gc, const std::string& op)
    : CFilter(gc, 1, this)
    , op(operatorExpr.getOpField(op))
  { 
    StdString input_op_expression=op;
    if(input_op_expression == "neg")
      op_expression = "-";
    else if(input_op_expression == "sin")
      op_expression = "sin";
    else if(input_op_expression == "cos")
      op_expression = "cos";
    else if(input_op_expression == "tan")
      op_expression = "tan";
    else if(input_op_expression == "exp")
      op_expression = "exp";
    else if(input_op_expression == "log")
      op_expression = "log";
    else if(input_op_expression == "log10")
      op_expression = "log10";
    else if(input_op_expression == "sqrt")
      op_expression = "sqrt";
    else
      op_expression = " ";
  };

  CDataPacketPtr CUnaryArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
  {
    if(this->tag)
    {
      this->filterID = InvalidableObject::filterIdGenerator++;
      
      if(CWorkflowGraph::mapFieldToFilters_ptr==0) CWorkflowGraph::mapFieldToFilters_ptr = new std::unordered_map <StdString, vector <int> >;
      if(CWorkflowGraph::mapFilters_ptr==0) CWorkflowGraph::mapFilters_ptr = new std::unordered_map <int, StdString>;


      (*CWorkflowGraph::mapFilters_ptr)[this->filterID] = op_expression +" F Filter" ;
      std::cout<<"CunaryArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;

      StdString str = data[0]->fieldID +" ts=" + to_string(data[0]->timestamp);
      (*CWorkflowGraph::mapFieldToFilters_ptr)[str].push_back(data[0]->src_filterID);
      (*CWorkflowGraph::mapFieldToFilters_ptr)[str].push_back(this->filterID);   
  
    }

    CDataPacketPtr packet(new CDataPacket);
    packet->date = data[0]->date;
    packet->timestamp = data[0]->timestamp;
    packet->status = data[0]->status;
    packet->fieldID = this->output_field_id;

    if (packet->status == CDataPacket::NO_ERROR)
      packet->data.reference(op(data[0]->data));

    if(this->tag) packet->src_filterID = this->filterID;

    return packet;
  }
} // namespace xios
